Vous ne pouvez pas sélectionner plus de 25 sujets Les noms de sujets doivent commencer par une lettre ou un nombre, peuvent contenir des tirets ('-') et peuvent comporter jusqu'à 35 caractères.
 
 
 
 

314 lignes
14 KiB

  1. #!/bin/sh
  2. [ ! -f "$HOME/.password-store/.gpg-id" ] && printf "\`pass\` must be installed and initialized to encrypt passwords.\\nBe sure it is installed and run \`pass init <yourgpgemail>\`.\\nIf you don't have a GPG public private key pair, run \`gpg --full-gen-key\` first.\\n" && exit
  3. ! command -v mbsync >/dev/null && printf "\`mbsync\` must be installed to run mutt-wizard.\\n" && exit
  4. muttdir="$HOME/.config/mutt" # Main mutt config location
  5. accdir="$muttdir/accounts" # Directory for account settings
  6. maildir="$HOME/.local/share/mail" # Location of mail storage
  7. namere="^[a-z_][a-z0-9_-]*$" # Regex to ensure viable username
  8. emailre=".\+@.\+\\..\+" # Regex to confirm valid email address
  9. muttshare="/usr/share/mutt-wizard"
  10. mbsyncrc="$HOME/.mbsyncrc"
  11. mwconfig="$muttshare/mutt-wizard.muttrc"
  12. cachedir="$HOME/.cache/mutt-wizard"
  13. muttrc="$muttdir/muttrc"
  14. ssltype="IMAPS" # This is later changed to `None` later in the script if using Protonmail
  15. for x in "/etc/ssl/certs/ca-certificates.crt" "/etc/pki/tls/certs/ca-bundle.crt" "/etc/ssl/ca-bundle.pem" "/etc/pki/tls/cacert.pem" "/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem"
  16. do
  17. [ -f "$x" ] && sslcert="$x" && break
  18. done || { echo "CA Certificate not found. Please install one or link it to /etc/ssl/certs/ca-certificates.crt" && exit 1 ;}
  19. getaccounts() { accounts="$(find "$accdir" -type f | grep -o "[0-9]-.*.muttrc" | sed "s/-/: /;s/\..*//" | sort -n)" ;}
  20. list() { getaccounts && [ -n "$accounts" ] && echo "$accounts" ;}
  21. getprofiles() { \
  22. unset msmtp_header msmtp_profile mutt_profile mbsync_profile
  23. printf "Creating profiles for \`%s\`..." "$title"
  24. msmtp_header="defaults
  25. auth on
  26. tls on
  27. tls_trust_file $sslcert
  28. logfile ~/.config/msmtp/msmtp.log
  29. "
  30. msmtp_profile="account $title
  31. host $smtp
  32. port $sport
  33. from $fulladdr
  34. user $login
  35. passwordeval \"pass mutt-wizard-$title\"
  36. "
  37. mbsync_profile="IMAPStore $title-remote
  38. Host $imap
  39. Port $iport
  40. User $login
  41. PassCmd \"pass mutt-wizard-$title\"
  42. SSLType $ssltype
  43. CertificateFile $sslcert
  44. MaildirStore $title-local
  45. Subfolders Verbatim
  46. Path ~/.local/share/mail/$title/
  47. Inbox ~/.local/share/mail/$title/INBOX
  48. Flatten .
  49. Channel $title
  50. Expunge Both
  51. Master :$title-remote:
  52. Slave :$title-local:
  53. Patterns * !\"[Gmail]/All Mail\"
  54. Create Both
  55. SyncState *
  56. # End profile
  57. "
  58. if [ "$accounttype" = "offline" ]; then
  59. mutt_profile="# vim: filetype=neomuttrc
  60. # muttrc file for account $title
  61. set realname = \"$realname\"
  62. set from = \"$fulladdr\"
  63. set sendmail = \"msmtp -a $title\"
  64. alias me $realname <$fulladdr>
  65. set folder = \"$maildir/$title\"
  66. set header_cache = $cachedir/$title/headers
  67. set message_cachedir = $cachedir/$title/bodies
  68. set mbox_type = Maildir
  69. bind index,pager gg noop
  70. bind index,pager g noop
  71. bind index,pager M noop
  72. bind index,pager C noop
  73. bind index gg first-entry
  74. macro index o \"<shell-escape>mailsync -V $title<enter>\" \"run mbsync to sync $title\"
  75. unmailboxes *
  76. "
  77. else
  78. mutt_profile="# vim: filetype=neomuttrc
  79. # muttrc file for account $title
  80. set realname = \"$realname\"
  81. set from = \"$fulladdr\"
  82. set sendmail = \"/usr/bin/msmtp -a $title\"
  83. alias me $realname <$fulladdr>
  84. set folder = \"imaps://$fulladdr@$imap:$iport\"
  85. set imap_user = \"$login\"
  86. set header_cache = $cachedir/$title/headers
  87. set message_cachedir = $cachedir/$title/bodies
  88. set imap_pass = \`pass mutt-wizard-$title\`
  89. set mbox_type = Maildir
  90. set ssl_starttls = yes
  91. set ssl_force_tls = yes
  92. bind index,pager gg noop
  93. bind index,pager g noop
  94. bind index,pager M noop
  95. bind index,pager C noop
  96. bind index gg first-entry
  97. unmailboxes *
  98. "
  99. fi
  100. printf "DONE.\\n"
  101. }
  102. askinfo() { \
  103. printf "Insert the \033[31memail address\033[0m that you want to autoconfigure for mutt/mbsync\\n\tEmail: \033[36m"
  104. read -r fulladdr
  105. printf "\033[0m"
  106. while ! echo "$fulladdr" | grep "$emailre" >/dev/null; do
  107. printf "That is not a valid \033[31memail address\033[0m, please retype the desired email.\\n\\nEmail: \033[36m\t"
  108. read -r fulladdr
  109. printf "\033[0m"
  110. done
  111. domain="$(echo "$fulladdr" | sed "s/.*@//")"
  112. printf "\\nSearching for \033[32m%s\033[0m in \033[34m\`domains.csv\`\033[0m..." "$domain"
  113. serverinfo="$(grep "^$domain" "$muttshare/domains.csv" 2>/dev/null)"
  114. if [ -z "$serverinfo" ]; then
  115. printf "Your email domain is not in mutt-wizard's database yet.\\nmutt-wizard will still autoconfigure everything, but you will have to manually type in your service's IMAP and SMTP server information.\\nYou can usually quickly find this by internet searching for it.\\n"
  116. printf "Insert the IMAP server for your email provider (excluding the port number)\\n\033[36m\t"
  117. read -r imap
  118. printf "\033[0mWhat is your server's IMAP port number? (Usually something like 993)\\n\033[36m\t"
  119. read -r iport
  120. printf "\033[0mInsert the SMTP server for your email provider (excluding the port number)\\n\033[36m\t"
  121. read -r smtp
  122. printf "\033[0mWhat is your server's SMTP port number? (Usually 587 or 465)\\n\033[36m\t"
  123. read -r sport
  124. printf "\033[0m\\nGreat! If you want to be helpful, copy the line below and you can add it to the \`domains.csv\` file on Github.\\nThis will make things easier for others who use your email provider.\\n\\n%s,%s,%s,%s,%s\\n\\nAlthough be sure to test to see if these settings work first! ;-)\\n" "$domain" "$imap" "$iport" "$smtp" "$sport"
  125. else
  126. IFS=, read -r service imap iport smtp sport <<EOF
  127. $serverinfo
  128. EOF
  129. printf "\\n\033[3;33mCongrats!\033[0m Server info has automatically be found, so you won't have to look anything up!\\n\t\033[1mIMAP server\033[0m: %s\\n\t\033[1mIMAP port\033[0m: %s\\n\t\033[1mSMTP server\033[0m: %s\\n\t\033[1mSMTP port\033[0m: %s\\nThis data will be used by the wizard.\\n" "$imap" "$iport" "$smtp" "$sport"
  130. case "$service" in
  131. gmail.com) printf "\033[31mREMEMBER: Gmail users must enable \"less secure\" (third-party) applications first for the sync to work:\\nhttps://support.google.com/accounts/answer/6010255\\n\033[0m" ;;
  132. protonmail.*) printf "\033[31mREMEMBER: Protonmail users must install and configure Protonmail Bridge first for the sync to work:\\nhttps://protonmail.com/bridge/\\n\033[0m" && ssltype="None" ;;
  133. esac
  134. fi
  135. printf "Enter the \033[35mfull name\033[0m you want to be identified by on this account.\\n\tReal name: "
  136. read -r realname
  137. printf "Enter a short, \033[36mone-word identifier\033[0m for this email account that will distinguish them from any other accounts you add.\\n\tAccount name: "
  138. read -r title
  139. while ! echo "$title" | grep "$namere" >/dev/null || ls "$accdir"/[0-9]"-$title.muttrc" >/dev/null 2>&1; do
  140. printf "\033[31mTry again\033[0m. Pick a nickname that is one word only including lowercase letters and _ or - and that you have \033[1mnot\033[0m used before.\\n\tAccount name: \033[36m\t"
  141. read -r title
  142. printf "\033[0m"
  143. done
  144. printf "If your account has a special username different from your address, insert it now. Otherwise leave this prompt totally blank.\\n\033[34mMost accounts will not have a separate login, so you should probably leave this blank.\033[0m\\n\tLogin(?): \033[36m"
  145. read -r login
  146. printf "\033[0m"
  147. [ -z "$login" ] && login="$fulladdr"
  148. getpass
  149. getprofiles
  150. mkdir -p "$muttdir" "$accdir" "$cachedir/$title/bodies" "$HOME/.config/msmtp"
  151. getaccounts
  152. for x in $(seq 1 9); do echo "$accounts" | grep "$x" >/dev/null 2>&1 || { export idnum="$x"; break ;}; done
  153. [ ! -f "$HOME/.config/msmtp/config" ] && echo "$msmtp_header" > "$HOME/.config/msmtp/config"
  154. echo "$msmtp_profile" >> "$HOME/.config/msmtp/config"
  155. echo "$mutt_profile" > "$accdir/$idnum-$title.muttrc"
  156. echo "$mbsync_profile" >> "$mbsyncrc"
  157. notmuchauto
  158. [ ! -f "$muttrc" ] && echo "# vim: filetype=neomuttrc" > "$muttrc" && echo "muttrc created."
  159. ! grep "^source.*mutt-wizard.muttrc" "$muttrc" >/dev/null && echo "source $mwconfig # mw-autogenerated" >> "$muttrc"
  160. ! grep "^source.*.muttrc" "$muttrc" | grep -v "$mwconfig" >/dev/null && echo "source $accdir/$idnum-$title.muttrc # mw-autogenerated" >> "$muttrc"
  161. echo "macro index,pager i$idnum '<sync-mailbox><enter-command>source $accdir/$idnum-$title.muttrc<enter><change-folder>!<enter>;<check-stats>' \"switch to $fulladdr\" # mw-autogenerated" >> "$muttrc"
  162. }
  163. getpass() { while : ; do pass rm -f "mutt-wizard-$title" >/dev/null 2>&1
  164. pass insert "mutt-wizard-$title" && break; done ;}
  165. formatShortcut() { \
  166. while read -r data; do { echo "macro index,pager g$1 \"<change-folder>$data<enter>\" \"go to $2\" # mw-autogenerated"
  167. echo "macro index,pager M$1 \"<save-message>$data<enter>\" \"move mail to $2\" # mw-autogenerated"
  168. echo "macro index,pager C$1 \"<copy-message>$data<enter>\" \"copy mail to $2\" # mw-autogenerated"; } >> "$accdir/$idnum-$title.muttrc"
  169. done ;}
  170. tryconnect() { mkdir -p "$maildir/$title"
  171. if mailboxes="$(mbsync -l "$title" | sed 's/\//./')" >/dev/null 2>&1 && [ -n "$mailboxes" ]; then
  172. [ "$accounttype" = "online" ] && sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
  173. printf "\033[32mMailboxes detected.\033[0m\\n"
  174. echo "$mailboxes" | xargs -I {} mkdir -p "$maildir/$title/{}"
  175. return 0
  176. else
  177. printf "\033[31m\033[31mLog-on not successful.\033[0m\\nIt seems that either you inputted the wrong password or server settings, or there are other requirements for your account out of the control of mutt-wizard.\\n"
  178. return 1
  179. fi ;}
  180. finalize() { \
  181. boxes="$(du -a "$maildir/$title/"* -d 0 | sed "s/^.*\//=/")"
  182. [ -z "$boxes" ] && printf "\033[31mNo local mailboxes have been detected for %s.\033[0m\\nThis means that mbsync has not been successfully run.\\nRun mbsync, and if it has an error, be sure to check your password and server settings manually if needbe.\\n" "$title" && return
  183. printf "Setting default mailboxes for your Inbox, Sent, Drafts and Trash in mutt...\\n"
  184. spoolfile=$(echo "$boxes" | grep -i -m 1 inbox | sed 's/=/+/g')
  185. record=$(echo "$boxes" | grep -i -m 1 sent | sed 's/=/+/g')
  186. postponed=$(echo "$boxes" | grep -i -m 1 draft | sed 's/=/+/g')
  187. trash=$(echo "$boxes" | grep -i -m 1 trash | sed 's/=/+/g')
  188. sed -i "/^mailboxes\|^set record\|^set postponed\|^set trash\|^set spoolfile/d" "$accdir/$idnum-$title.muttrc"
  189. { echo "set spoolfile = \"$spoolfile\""; echo "set record = \"$record\""; echo "set postponed = \"$postponed\""; echo "set trash = \"$trash\""; } >> "$accdir/$idnum-$title.muttrc"
  190. echo "mailboxes =$title ===================== $(echo "$boxes" | sed -e "s/^\|$/\"/g" | tr "\n" " ")" >> "$accdir/$idnum-$title.muttrc"
  191. printf "Setting up your keyboard shortcuts for jumping between mailboxes...\\n"
  192. sed -i "/# mw-autogenerated/d" "$accdir/$idnum-$title.muttrc"
  193. echo "$boxes" | grep -i inbox | head -n 1 | formatShortcut i inbox
  194. echo "$boxes" | grep -i sent | head -n 1 | formatShortcut s sent
  195. echo "$boxes" | grep -i draft | head -n 1 | formatShortcut d drafts
  196. echo "$boxes" | grep -i trash | head -n 1 | formatShortcut t trash
  197. echo "$boxes" | grep -i spam | head -n 1 | formatShortcut S spam
  198. echo "$boxes" | grep -i junk | head -n 1 | formatShortcut j junk
  199. echo "$boxes" | grep -i archive | head -n 1 | formatShortcut a archive
  200. [ "$accounttype" = "offline" ] && printf "All done.\\n\033[33mYou should now be able to run \`\033[32mmbsync %s\033[33m\` to begin to download your mail.\033[0m\\n" "$title"
  201. return 0
  202. }
  203. confirm() { printf "Do you want to to %s? [y/N]\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  204. printf "Are you really, really sure you want to %s?\\n\t" "$@" && read -r input && ! echo "$input" | grep -i "^y$\|^yes$" >/dev/null && printf "That doesn't seem like a yes to me.\\n\\n" && return 1
  205. return 0 ;}
  206. pick() { printf "Select an accounts to %s:\\n" "$1"
  207. list
  208. read -r input
  209. [ -z "$input" ] && return 1
  210. title="$(echo "$accounts" | grep "$input" | awk '{print $2}')"
  211. [ -z "$title" ] && printf "Invalid response." && return 1
  212. return 0 ;}
  213. delete() { sed -i "/IMAPStore $title-remote$/,/# End profile/d" "$mbsyncrc"
  214. rm -rf "${cachedir:?}/${title:?}" "$accdir/"[1-9]"-$title.muttrc"
  215. sed -i "/[0-9]-$title.muttrc/d" "$muttrc"
  216. sed -i "/account $title/,/^\(\s*$\|account\)/d" "$HOME/.config/msmtp/config"
  217. }
  218. choosecron() { ! pgrep -x cron\|crond >/dev/null && echo "No cron manager running. Install/enable one and then select this option again." && return 1
  219. if crontab -l | grep mailsync >/dev/null; then
  220. echo "Active mail sync cronjob detected. Do you want to remove it?"
  221. printf "\033[36m\t"
  222. read -r rmyn
  223. printf "\033[0m"
  224. echo "$rmyn" | grep -i "^y\(es\)*$" >/dev/null && crontab -l | sed '/mailsync/d' | crontab - >/dev/null && echo "Mail sync turned off."
  225. else
  226. echo "How many minutes between each mail sync?"
  227. printf "\033[36m\t"
  228. read -r minnum
  229. printf "\033[0m"
  230. while ! echo "$minnum" | grep "^[0-9]\+$" >/dev/null; do
  231. printf "That doesn't look like a number. How many minutes between each mail sync?\\n\033[36m\t"
  232. read -r minnum
  233. printf "\033[0m"
  234. done
  235. (crontab -l; echo "*/$minnum * * * * export DBUS_SESSION_BUS_ADDRESS=unix:path=/run/user/$(id -u)/bus; export DISPLAY=:0; . \$HOME/.profile; $(type mailsync | cut -d' ' -f3)") | crontab - &&
  236. echo "Cronjob added. Mail will sync every $minnum minutes. Be sure you have your cron manager running."
  237. fi ;}
  238. asktype() { while : ; do
  239. printf "Do you want to keep your mail for this account offline with mbsync? [yes/no]\\n\t"
  240. read -r offnot
  241. case "$offnot" in
  242. [Yy][Ee][Ss]) accounttype="offline" && break ;;
  243. [Nn][Oo]) accounttype="online" && break ;;
  244. *) echo "Write out either yes or no completely. Try again or press ctrl-c to quit." ;;
  245. esac; done ;}
  246. purge() { confirm "delete all account data" || exit
  247. rm -rf "$mbsyncrc" "$accdir" "$HOME/.config/msmtp" "$cachedir"
  248. echo "All configs and account settings have been purged."
  249. sed -i "/\# mw-autogenerated/d" "$muttrc"
  250. }
  251. notmuchauto() { \
  252. [ -z "$NOTMUCH_CONFIG" ] && NOTMUCH_CONFIG="$HOME/.notmuch-config"
  253. [ -f "$NOTMUCH_CONFIG" ] && return 0
  254. nmbasic="[database]
  255. path=$maildir
  256. [user]
  257. name=$realname
  258. primary_email=$fulladdr
  259. [new]
  260. tags=unread;inbox;
  261. ignore=
  262. [search]
  263. exclude_tags=deleted;spam;
  264. [maildir]
  265. synchronize_flags=true
  266. [crypto]
  267. gpg_path=gpg"
  268. echo "$nmbasic" > "$NOTMUCH_CONFIG" ;}
  269. case "$1" in
  270. ls) list ;;
  271. add) asktype && askinfo && tryconnect && finalize || delete ;;
  272. pass) pick "change the password of" && getpass ;;
  273. delete) pick delete && confirm "delete the \`$title\` profile" && delete ;;
  274. purge) purge ;;
  275. cron) choosecron ;;
  276. *) cat << EOF
  277. mw: mutt-wizard, auto-configure email accounts for mutt
  278. including downloadable mail with \`isync\`.
  279. Allowed options:
  280. add Add and autoconfigure an email address (9 max.)
  281. ls List configured accounts
  282. delete Pick an account to delete
  283. purge Delete all accounts and settings
  284. cron Enable or disable an autosync via cronjob
  285. all else Print this message
  286. NOTE: Once at least one account is added, you can run
  287. \`mbsync -a\` to begin downloading mail.
  288. EOF
  289. esac